ALTER SESSION SET "_ORACLE_SCRIPT"=true;

CREATE USER WMAPI IDENTIFIED BY xR9sJwX82ZHy6uMJ;
GRANT CONNECT, RESOURCE, DBA TO WMAPI;
GRANT CREATE SESSION TO WMAPI;
GRANT ALL PRIVILEGES TO WMAPI;
GRANT UNLIMITED TABLESPACE TO WMAPI;

CREATE TABLE WMAPI.USERS
( USER_ID NUMBER GENERATED ALWAYS as IDENTITY(START with 1 INCREMENT by 1),
  USERNAME VARCHAR2(254),
  PASSWORD VARCHAR2(120),
  F_NAME VARCHAR2(35),
  L_NAME VARCHAR2(35),
  IS_ADMIN NUMBER(1,0) DEFAULT 0,
  PAID_DAYS NUMBER DEFAULT 20 NOT NULL,
  UNPAID_DAYS NUMBER DEFAULT 90 NOT NULL,
  SICK_LEAVE NUMBER DEFAULT 40 NOT NULL,
  USER_DATE_CREATED DATE NOT NULL,
  USER_CREATOR_ID NUMBER,
  USER_DATE_LAST_CHANGED DATE NOT NULL,
  USER_LAST_CHANGE_USER_ID NUMBER,
  CONSTRAINT USERS_PK PRIMARY KEY (USER_ID),
  CONSTRAINT USERNAME_K UNIQUE (USERNAME),
  CONSTRAINT USERS_CREATOR_USER_FK FOREIGN KEY (USER_CREATOR_ID) REFERENCES WMAPI.USERS (USER_ID) ON DELETE SET NULL,
  CONSTRAINT USERS_LASTCHANGE_USER_FK FOREIGN KEY (USER_LAST_CHANGE_USER_ID) REFERENCES WMAPI.USERS (USER_ID) ON DELETE SET NULL,
  CHECK (PAID_DAYS>=0),
  CHECK (UNPAID_DAYS>=0),
  CHECK (SICK_LEAVE>=0)
);

CREATE TABLE WMAPI.TEAMS
( TEAM_ID NUMBER GENERATED ALWAYS as IDENTITY(START with 1 INCREMENT by 1),
  TEAM_TITLE VARCHAR2(120) NOT NULL,
  TEAM_DESCRIPTION VARCHAR2(300),
  TEAM_LEADER NUMBER,
  TEAM_DATE_CREATED DATE NOT NULL,
  TEAM_CREATOR_ID NUMBER,
  TEAM_DATE_LAST_CHANGED DATE NOT NULL,
  TEAM_LAST_CHANGE_USER_ID NUMBER,
  CONSTRAINT TEAMS_PK PRIMARY KEY (TEAM_ID),
  CONSTRAINT TEAMS_K UNIQUE (TEAM_TITLE),
  CONSTRAINT TEAM_LEADER_USER_FK FOREIGN KEY (TEAM_LEADER) REFERENCES WMAPI.USERS (USER_ID) ON DELETE SET NULL,
  CONSTRAINT TEAMS_CREATOR_USER_FK FOREIGN KEY (TEAM_CREATOR_ID) REFERENCES WMAPI.USERS (USER_ID) ON DELETE SET NULL,
  CONSTRAINT TEAMS_LASTCHANGE_USER_FK FOREIGN KEY (TEAM_LAST_CHANGE_USER_ID) REFERENCES WMAPI.USERS (USER_ID) ON DELETE SET NULL
);

CREATE TABLE WMAPI.MEMBERS
( MEMBER_USER_ID NUMBER,
  MEMBER_TEAM_ID NUMBER,
  CONSTRAINT USERS_TEAMS_K UNIQUE (MEMBER_USER_ID, MEMBER_TEAM_ID),
  CONSTRAINT USERS_TEAMS_USER_FK FOREIGN KEY (MEMBER_USER_ID) REFERENCES WMAPI.USERS (USER_ID) ON DELETE CASCADE,
  CONSTRAINT USERS_TEAMS_TEAM_FK FOREIGN KEY (MEMBER_TEAM_ID) REFERENCES WMAPI.TEAMS (TEAM_ID) ON DELETE CASCADE
);

CREATE TABLE WMAPI.TIME_OFF_REQUESTS
( TIME_OFF_ID NUMBER GENERATED ALWAYS as IDENTITY(START with 1 INCREMENT by 1),
  TIME_OFF_TYPE NUMBER(1,0) NOT NULL,
  TIME_OFF_START DATE NOT NULL,
  TIME_OFF_END DATE NOT NULL,
  TIME_OFF_REASON VARCHAR2(300),
  TIME_OFF_STATUS NUMBER(1,0) DEFAULT 0 NOT NULL,
  TIME_OFF_DATE_CREATED DATE NOT NULL,
  TIME_OFF_CREATOR_ID NUMBER,
  TIME_OFF_LAST_CHANGED DATE NOT NULL,
  TIME_OFF_LAST_CHANGE_USER_ID NUMBER,
  CONSTRAINT TIME_OFF_PK PRIMARY KEY (TIME_OFF_ID),
  CONSTRAINT TIME_OFF_CREATOR_USER_FK FOREIGN KEY (TIME_OFF_CREATOR_ID) REFERENCES WMAPI.USERS (USER_ID) ON DELETE CASCADE,
  CONSTRAINT TIME_OFF_LASTCHANGE_USER_FK FOREIGN KEY (TIME_OFF_LAST_CHANGE_USER_ID) REFERENCES WMAPI.USERS (USER_ID) ON DELETE SET NULL
);

CREATE TABLE WMAPI.APPROVALS
( APPROVAL_TIME_OFF_ID NUMBER,
  APPROVER_ID NUMBER,
  CONSTRAINT APPROVALS UNIQUE (APPROVAL_TIME_OFF_ID, APPROVER_ID),
  CONSTRAINT APPROVALS_TIME_OFF_FK FOREIGN KEY (APPROVAL_TIME_OFF_ID) REFERENCES WMAPI.TIME_OFF_REQUESTS (TIME_OFF_ID) ON DELETE CASCADE,
  CONSTRAINT APPROVALS_USERS_FK FOREIGN KEY (APPROVER_ID) REFERENCES WMAPI.USERS (USER_ID) ON DELETE CASCADE
);

CREATE USER WMAPI_APP IDENTIFIED BY PVkgDq5sE7kL8pC3;
GRANT CONNECT, RESOURCE TO WMAPI_APP;
GRANT CREATE SESSION TO WMAPI_APP;
GRANT UNLIMITED TABLESPACE TO WMAPI_APP;

GRANT
    SELECT,
    INSERT,
    UPDATE,
    DELETE
    ON
        WMAPI.USERS
    TO
    WMAPI_APP;

GRANT
    SELECT,
    INSERT,
    UPDATE,
    DELETE
    ON
        WMAPI.TEAMS
    TO
    WMAPI_APP;

GRANT
    SELECT,
    INSERT,
    UPDATE,
    DELETE
    ON
        WMAPI.MEMBERS
    TO
    WMAPI_APP;

GRANT
    SELECT,
    INSERT,
    UPDATE,
    DELETE
    ON
        WMAPI.TIME_OFF_REQUESTS
    TO
    WMAPI_APP;

GRANT
    SELECT,
    INSERT,
    UPDATE,
    DELETE
    ON
        WMAPI.APPROVALS
    TO
    WMAPI_APP;

INSERT INTO WMAPI.USERS
(USERNAME,
 PASSWORD,
 F_NAME,
 L_NAME,
 IS_ADMIN,
 USER_DATE_CREATED,
 USER_CREATOR_ID,
 USER_DATE_LAST_CHANGED,
 USER_LAST_CHANGE_USER_ID)
VALUES
('admin',
 '$2a$10$CRvGSRmDrTJQUhej7c7HR.VmVznV9LUtM7UurXnyFLoc7p73yypOa',
 'Admin',
 'Admin',
 1,
 TO_DATE('2003/05/03', 'yyyy/mm/dd'),
 1,
 TO_DATE('2003/05/03', 'yyyy/mm/dd'),
 1);

COMMIT;